/***************************************************************************
                          kpncalc.h  -  description
                             -------------------
    begin                : Sun Nov 21 1999
    copyright            : (C) 1999 by B. Heath Robinson
    email                : bheath@earthlink.net
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KPNCALC_H
#define KPNCALC_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <kseparator.h>
#include <qpushbutton.h>
#include <qlistbox.h>
#include <qlabel.h>
//Generated area. DO NOT EDIT!!!(end)

/**
  *@author B. Heath Robinson
  */

#include <kapp.h>
#include "kstack.h"

class KPNCalc : public QWidget  {
   Q_OBJECT
public: 
	KPNCalc(QWidget *parent=0, const char *name=0);
	virtual ~KPNCalc();

private:
	KStack * calcStack;
	KStack * undoStack;
	int IOBase;
	int angleUnit;
	int arc;
	int hyp;
	void ReloadGrid();
	void enableBinInput();
	void enableHexInput();
	void enableDecInput();
	KElement * createNewElement(const char * sStringRep);
	int validateOperation(int stackHtReq);
	void RefreshStatus();
	void addCharToBuffer(const char * c);
	void restoreUndoStack();
	void saveUndo();
  void setButtonAccels();
  void setButtonPixmaps();
  void connectSlots();;
	
public slots:
	void butBaseClicked();
	void butAngleClicked();
	void butOneClicked();
	void butTwoClicked();
	void butThreeClicked();
	void butFourClicked();
	void butFiveClicked();
	void butSixClicked();
	void butSevenClicked();
	void butEightClicked();
	void butNineClicked();
	void butZeroClicked();
	void butAClicked();
	void butBClicked();
	void butCClicked();
	void butDClicked();
	void butEClicked();
	void butFClicked();
	void butPeriodClicked();
	void butNegateClicked();
	void butExpNotationClicked();
	void butEnterClicked();
	void butSwapClicked();
	void butRollClicked();
	void butFlipClicked();
	void butFloatClicked();
	void butSinkClicked();
	void butDeleteClicked();
	void butClearClicked();
	void butBackClicked();
	void butCancelClicked();
	void butANDClicked();
	void butORClicked();
	void butComplimentClicked();
	void butAddClicked();
	void butSubtractClicked();
	void butMultiplyClicked();
	void butDivideClicked();
	void butModulousClicked();
	void butInverseClicked();
	void butPowerClicked();
	void butRootClicked();
	void butUndoClicked();
	void butArcClicked();
	void butHypClicked();	
	void butSinClicked();
	void butCosClicked();
	void butTanClicked();
	void butLnClicked();
	void butLogClicked();
	void butE2XClicked();
	void butTen2XClicked();
	void butFactorialClicked();
	void butPasteClicked();
	void butCopyClicked();
	void butHelpClicked();

protected:
	void keyPressEvent( QKeyEvent *k);
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	KSeparator *KSeparator_3;
	QPushButton *butPaste;
	QPushButton *butAngle;
	QPushButton *butHyp;
	QListBox *lstStack;
	QPushButton *butSix;
	QPushButton *butNine;
	QPushButton *butThree;
	QPushButton *butEight;
	QPushButton *butFive;
	QPushButton *butTwo;
	QPushButton *butPeriod;
	QPushButton *butSeven;
	QPushButton *butOne;
	QPushButton *butFour;
	QPushButton *butZero;
	QPushButton *butDivide;
	QPushButton *butMultiply;
	QPushButton *butNegate;
	QPushButton *butEnter;
	QPushButton *butAdd;
	QPushButton *butSubtract;
	QPushButton *butDelete;
	QPushButton *butSwap;
	QPushButton *butClear;
	QPushButton *butUndo;
	QPushButton *butPower;
	QPushButton *butModulous;
	QPushButton *butInverse;
	QPushButton *butRoot;
	QLabel *lblBuffer;
	QLabel *lblStatus;
	QPushButton *butSin;
	QPushButton *butTan;
	QPushButton *butCos;
	QPushButton *butLog;
	QPushButton *butLn;
	QPushButton *butFactorial;
	QPushButton *butF;
	QPushButton *butE;
	QPushButton *butD;
	QPushButton *butC;
	QPushButton *butB;
	QPushButton *butA;
	QPushButton *butCopy;
	QPushButton *butOR;
	QPushButton *butBase;
	QPushButton *butAND;
	QPushButton *butCompliment;
	QPushButton *butExpNotation;
	QPushButton *butArc;
	QPushButton *butBack;
	QPushButton *butCancel;
	QPushButton *butRoll;
	QPushButton *butFlip;
	QPushButton *butFloat;
	QPushButton *butSink;
	QPushButton *butE2X;
	QPushButton *butTen2X;
	QPushButton *butHelp;
	//Generated area. DO NOT EDIT!!!(end)

};

#endif
